import {createStore, applyMiddleware, combineReducers} from 'redux';
import thunk from 'redux-thunk';
import { actionAuthLogin } from '../actions'


const reducers = {
    promise(state={}, action){
        if (['LOGOUT', 'LOGIN'].includes(action.type)) return {}
        if (action.type === 'PROMISE'){
            const { name="default", status, payload, error} = action
            if (status){
                return {
                    ...state, [name]: {status, payload: (status === 'PENDING' && state[name] && state[name].payload) || payload, error}
                }
            }
        }
        return state;
    },
    auth(state, action){ //....
        if (state === undefined){
            //добавить в action token из localStorage, и проимитировать LOGIN (action.type = 'LOGIN')
            return {}
        }
        if (action.type === 'LOGIN'){
            console.log('ЛОГИН')
            //+localStorage
            //jwt_decode
//            return {token: action.jwt, payload: jwt_decode(action.jwt)}
        }
        if (action.type === 'LOGOUT'){
            console.log('ЛОГАУТ')
            //-localStorage
            //вернуть пустой объект
            return {}
        }
        return state
    },
    cart: localStored('cart', (state={/*Id1: 5, Id2: 25, Id3: 1*/}, {type, _id, count}) => {
        const types = {
            CART_ADD(){
                return предыдущее состояние и добавить новый товар, а если старый, то +1
            },
            CART_DELETE(){
                return деструктурнуть с ... шобы лишнее удалить
            },
            CART_SET(){
                return предыдущее состояние и установить количество одного конкретного товара (нужно для оформления, там обычно любое число можно)
            },
            CART_CLEAR(){
                return {}
            }
        }

        if (type in types)
            return types[type]()

        return state;
    }),
}

function localStored(name, reducer){
    должна сохранить и восстановить все шо можно в localstorage
    return (state, action) => ведет себя как reducer, но по пути сохраняет или восстанавливает из localStorage
}
//{
//    promise: {}
//}

let store = createStore(combineReducers(reducers), applyMiddleware(thunk))

store.subscribe(() => console.log(store.getState()))
//store.subscribe(() => {
    //const state = store.getState()
    //if (state.promise && state.promise.login && state.promise.login.payload){
        //store.dispatch(actionAuthLogin(state.promise.login.payload.login))
    //}
//})

const delay = ms => new Promise(ok => setTimeout(() => ok(ms), ms))


export default store

